Type meteor
Field x
Field y
End Type

Type torpedo
Field x
Field y
End Type

SeedRnd MilliSecs()

Miniwin = CreateWindow("",0,0,200,180,Desktop(),0)
CenterWindow Miniwin
CreateLabel("Whle einen Schwierigkeitsgrad",0,0,200,20,Miniwin)
but1 = CreateButton("sehr leicht",0,30,200,30,Miniwin)
but2 = CreateButton("leicht",0,60,200,30,Miniwin)
but3 = CreateButton("mittel",0,90,200,30,Miniwin)
but4 = CreateButton("Schwer",0,120,200,30,Miniwin)
but5 = CreateButton("Unmglich",0,150,200,30,Miniwin)

Repeat
Until WaitEvent() = $401
Select EventSource()
 Case but1 level = 100
 Case but2 level = 50
 Case but3 level = 10
 Case but4 level = 5
 Case but5 level = 2
End Select

Mainwin = CreateWindow("Flugzeug gegen Meteoriten",0,0,500,750,Desktop(),32)
CenterWindow Mainwin
Maincan = CreateCanvas(0,0,406,778,Mainwin)
Can2 = CreateCanvas(406,0,100,778,Mainwin)
SetBuffer CanvasBuffer(Can2)
ClsColor 127,127,127 : Cls : FlipCanvas Can2
SetBuffer CanvasBuffer(Maincan)
img_player = LoadImage("Zutaten\Flugzeug5.png") : MaskImage img_player,255,255,255
img_meteor = LoadImage("Zutaten\Meteorit4.png") : MaskImage img_meteor,255,255,255
img_torpedo = LoadImage("Zutaten\Torpedo1.png") : MaskImage img_torpedo,255,255,255
img_explosion = LoadImage("Zutaten\Explosion2.png") : MaskImage img_explosion,255,255,255
snd_abschuss = LoadSound("Zutaten\Abschuss.wav")
snd_explosion = LoadSound("Zutaten\Explosion.wav")
font1 = LoadFont("Courier New",22)
font2 = LoadFont("Impact",80)

playerX = 250
playerY = 600
timer = CreateTimer(60)
score = 0
health = 100


Repeat
 If KeyDown(1) Then End
 WaitTimer(timer)
 SetBuffer CanvasBuffer(Maincan)
 Cls
 For t.torpedo = Each torpedo
  t\y = t\y - 4
  DrawImage img_torpedo,t\x,t\y
  For m.meteor = Each meteor
   If RectsOverlap(t\x,t\y,25,50,m\x,m\y,25,25) Then
    DrawImage img_explosion,m\x-12,m\y-12
    PlaySound snd_explosion
    Delete m
    Delete t
    score = score + 1
    Exit
   EndIf
  Next
  If t <> Null Then
   If t\y < -50 Then Delete t
  EndIf
 Next
 DrawImage img_player,playerX,playerY
 For m.meteor = Each meteor
  m\y = m\y + 2
  If ImagesCollide(img_torpedo,m\x,m\y,0,img_player,playerX,playerY,0) Then
   PlaySound snd_explosion
   DrawImage img_explosion,m\x-12,m\y-12
   Delete m
   health = health - 5
  Else
   DrawImage img_meteor,m\x,m\y
  EndIf
  If m <> Null Then
   If m\y > 800 Then Delete m
  EndIf
 Next

 FlipCanvas Maincan

 If KeyDown(200) Then playerY = playerY - 2 : If playerY < 0 Then playerY = 0
 If KeyDown(203) Then playerX = playerX - 2 : If playerX < 0 Then playerX = 0
 If KeyDown(208) Then playerY = playerY + 2 : If playerY > 630 Then playerY = 630
 If KeyDown(205) Then playerX = playerX + 2 : If playerX > 300 Then playerX = 300

 If KeyHit(46) Then
  PlaySound snd_abschuss
  t.torpedo = New torpedo
  t\x = playerX + 30 - 12
  t\y = playerY + 10; - 30
 EndIf
 If KeyHit(47) Then
  PlaySound snd_abschuss
  t.torpedo = New torpedo
  t\x = playerX + 68 - 12
  t\y = playerY + 10; - 30
 EndIf
 If Rand(1,level) = 1 Then
  m.meteor = New meteor
  m\x = Rand(0,350)
  m\y = -30
 EndIf

 SetBuffer CanvasBuffer(Can2)
 Cls
 SetFont font1
 Color 255,255,255
 Text 50,10,"Punkte",1
 Color 255,0,0
 Text 50,40,score,1
 Color 255,255,255
 Text 50,80,"Energie",1
 Color 255,0,0
 Text 50,110,health+"%",1

 FlipCanvas Can2
 If health <= 0 Then Exit

Forever

SetBuffer CanvasBuffer(Maincan)
SetFont font2
Text 200,200,"GAME",1
FlipCanvas Maincan
Delay 1000
Text 200,400,"OVER",1
FlipCanvas Maincan
Delay 1000
Notify "Dein Ergebnis:"+Chr(13)+score+" Punkte"
End


Function CenterWindow(window)
 SetGadgetShape window,ClientWidth(Desktop())/2-GadgetWidth(window)/2,ClientHeight(Desktop())/2-GadgetHeight(window)/2,GadgetWidth(window),GadgetHeight(window)
End Function